Prime Path - poj3126 - 区间筛素数+bfs求最短路

Prime Path

Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 27722 Accepted: 15137

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 

1033
1733
3733
3739
3779
8779
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

Source

Northwestern Europe 2006

思路:

看到这个题肯定是要先把区间的素数给筛出来,要注意的是,看题中给的样例,[1033,8179]里有一步是8779,所以不能只把给的区间[a,b]的素数给筛出来,筛[1000,10000)。并把结果保存在区间[0,9000)里。

筛好后我们用bfs求到b的最短路,每个步都要符合,与前一步的4位数字只有一位不一样。

代码如下:

#include<iostream>
#include<cstdio>
#include<algorithm>
#include<string>
#include<cstring> 
#include<queue>
#include<cmath>
using namespace std;

bool is_prime_small[10000],is_prime[10000];
int a,b,d[10000];
const int INF=0x3f3f3f3f;
int a1=1000,b1=10000;

bool judge(int x,int y){
	int flag=0;
	for(int i=0;i<4;i++){
		if(x%10!=y%10)flag++;
		x/=10;
		y/=10;
	}
	return flag==1?1:0;
}

int bfs(){
	queue<int> que;
	for(int i=0;i<b1-a1;i++){
		d[i]=INF;
	}
	d[a-a1]=0;
	que.push(a-a1);
	while(que.size()){
		int num=que.front();que.pop();
		if(num+a1==b)break;
		for(int i=0;i<b1-a1;i++){
			if(is_prime[i]&&judge(a1+num,a1+i)&&d[i]==INF){
				d[i]=d[num]+1;
				que.push(i);
			}
		}	
	}
	return d[b-a1];
}

int main(){
	int t;
	scanf("%d",&t);
	//筛出[1000,10000)的素数 
	for(int i=0;i*i<b1;i++)is_prime_small[i]=true;
	for(int i=a;i<b1;i++)is_prime[i-a]=true;  
	for(int i=2;i*i<=b1;i++){
		if(is_prime_small[i]){
			for(int j=2*i;j*j<=b1;j+=i)is_prime_small[j]=false;
			for(int j=max(2,(a1+i-1)/i)*i;j<b1;j+=i)is_prime[j-a1]=false;
			
		}
	}
        while(t--){
    	    scanf("%d%d",&a,&b);
   	    int ans=bfs();
	    printf("%d\n",ans);
	}
}

 

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值